/* 

  RMC - Ron's MUD Client
  Copyright (C) 2000 Ron Martin <rmartin@cps.cmich.edu>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
*/

/* client.h */

#include <sys/socket.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <gtk/gtk.h>
#include <stdlib.h>

#define STATE_OPEN (1 << 0)
#define STATE_CONNECTED (1 << 1)
#define STATE_EDITING (1 << 2)

#define VERSION "v0.68"
/* 
   Change the DOC_PATH if you need to install the
   documentation elsewhere.
*/
#define DOC_PATH "/usr/local/doc/rmc/"

struct parse_type
{
	char * input_string;
	char * output_string;
	struct parse_type * next;
} parse_type;

struct log_info
{
	GtkWidget * log_widget;
	char * log_file;
	char * name;
	int log_to_window;
	struct log_info * next;
} log_info;

struct argument_info
{
	char * argument; /* the argument */
	struct argument_info * next;
} argument_info;

struct commands
{
	char * command;
	struct commands * prev;
	struct commands * next;
} commands;

struct conn_info
{
	char * mud_name; /* unique connection name */
	char * host_name;
	char * font_name;
	int port, descriptor, sock; /* port, socket descriptor, and gdk tag */
	float value;
	unsigned char state; /* connected? opened? editing? */
	struct parse_type * aliases;
	struct parse_type * triggers;
	struct log_info * logs;
	struct commands * history;
	GdkFont * font;
	struct conn_info * next;
} conn_info;

struct color_info
{
	int bold;
	int fg_color;
	int bg_color;
} color_info;

int new_socket(char * host_name, int port);
int error_handle(int);
